/*******************************************************************************
                                    ReSyEqVa                                    
                                    ========                                    

Resolve Systems of 2 Equations in 2 Variables
Copyright (C) 2010 Paul Kocialkowski

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#include "main.h"
#include "fract.h"
#include "input.h"

#define OF_THE_JEDI 0

int equa_1_x_fact=0, equa_1_y_fact=0, equa_1_result=0;
int equa_2_x_fact=0, equa_2_y_fact=0, equa_2_result=0;

void equations_resolve()
{
	int equa_x_lcm=lcm(equa_1_x_fact, equa_2_x_fact);
	int equa_1_x_lcm_result=equa_x_lcm / equa_1_x_fact;
	int equa_2_x_lcm_result=equa_x_lcm / equa_2_x_fact;

	int equa_1_y_lcm_result=equa_1_y_fact * (equa_1_x_lcm_result*-1);
	int equa_2_y_lcm_result=equa_2_y_fact * equa_2_x_lcm_result;

	int equa_1_result_lcm_result=equa_1_result * (equa_1_x_lcm_result*-1);
	int equa_2_result_lcm_result=equa_2_result * (equa_2_x_lcm_result);

	equa_1_x_lcm_result=equa_1_x_fact * (equa_1_x_lcm_result*-1);
	equa_2_x_lcm_result=equa_2_x_fact * equa_2_x_lcm_result;

	int equa_mix_y=equa_1_y_lcm_result + equa_2_y_lcm_result;
	int equa_mix_result=equa_1_result_lcm_result + equa_2_result_lcm_result;

	fract equa_mix_y_fract;
	equa_mix_y_fract.n=equa_mix_result,
	equa_mix_y_fract.d=equa_mix_y;

	fract equa_mix_x_fract;
	equa_mix_x_fract = fract_mul( fract_del(fract_from_num(equa_1_result),  fract_mul(equa_mix_y_fract, fract_from_num(equa_1_y_fact))) , fract_from_den(equa_1_x_fact) );

	printf("System: \n%dx + %dy = %d\n%dx + %dy = %d\n\nSolution: \nx=%d/%d\ny=%d/%d\n", equa_1_x_fact, equa_1_y_fact, equa_1_result, equa_2_x_fact, equa_2_y_fact, equa_2_result, equa_mix_x_fract.n, equa_mix_x_fract.d, equa_mix_y_fract.n, equa_mix_y_fract.d);
}

int main(int argc, char **argv)
{
	if(!args_parse(argc, argv))
	{
		char equation_1[32];
		char equation_2[32];

		printf("Equation #1: ");
		get_string(&equation_1, 32);
		printf("Equation #1: ");
		get_string(&equation_2, 32);
		
		input_equations_parse(equation_1, equation_2);
	}

	if(!equa_1_x_fact || !equa_1_y_fact || !equa_1_result || !equa_2_x_fact || !equa_2_y_fact || !equa_2_result)
	{
		printf("Error : the input is wrong : one (or more) element(s) is/are missing !\n");
		return OF_THE_JEDI;
	}

	equations_resolve();
	
	return OF_THE_JEDI;
}
